=== debian/changelog ===
flashprog (1.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1059043)

 -- Jakob Haufe <sur5r@debian.org>  Thu, 10 Apr 2025 09:12:21 +0200
