=== debian/watch ===
version=4

opts=pgpsigurlmangle=s%$%.asc%,uversionmangle=s%-rc%~rc% \
https://flashprog.org/releases/ flashprog-v@ANY_VERSION@.tar.bz2
