## flashprog 1.5

=== util/manibuilder/Makefile ===
--- 
+++ 
@@ -11,42 +11,62 @@
 spc :=
 spc := $(spc) $(spc)
 
+# Replace %$(2) -> %/$(2), e.g. armv5 with arm/v5 etc.
+preproc_subst = $(if $(2),$(call preproc_arch,$(patsubst %$(2),%/$(2),$(1)),$(3)),$(1))
+preproc_arch = $(call preproc_subst,$(1),$(firstword $(2)),$(wordlist 2,$(words $(2)),$(2)))
+
 # Get stem of multiarch tags of the form `stem[-variation]:arch-version`
 ma_stem = $(word 1,$(subst -,$(spc),$(subst :,$(spc),$(subst \:,$(spc),$(1)))))
 # Get stem of official tags of the form `arch/stem:version`
 official_stem = $(word 2,$(subst /,$(spc),$(subst :,$(spc),$(subst \:,$(spc),$(1)))))
+# Get arch prefix of official tags
+official_arch = $(word 1,$(subst /,$(spc),$(1)))
+# Create a platform string from the arch prefix, e.g. arm32v5 -> linux/arm/v5
+official_plat = linux/$(patsubst arm32%,arm%,$(call preproc_arch,$(call official_arch,$(1)),v5 v6 v7 v8))
 
 ident = $(subst /,_,$(subst :,_,$(subst \:,_,$(1))))
 
 include Makefile.env
 include Makefile.anita
+include Makefile.cross
 
 # $(1): mani tag
 # $(2): from tag
 # $(3): Dockerfile suffix
+# $(4): platform            (optional)
 define build_template
 Dockerfile.$(call ident,$(1)): Dockerfile.$(3) mani-wrapper.sh
 	$(QUIET_SETUP)sed -e 's|^FROM manibase|FROM $(2)|' $$< >$$@
 
 .INTERMEDIATE: Dockerfile.$(call ident,$(1))
 
-$(1)-build: Dockerfile.$(call ident,$(1))
-	$(QUIET_SETUP)docker build . -f $$< -t mani/$(1) --build-arg IDENT=$(call ident,$(1)) $$(DOCKER_BUILD_ARGS)
+$(1)-build: Dockerfile.$(call ident,$(1)) source-check-build
+	$(QUIET_SETUP)docker build . \
+		$(addprefix --platform$(spc),$(4)) -f $$< -t mani/$(1) \
+		--build-arg IDENT=$(call ident,$(1)) $$(DOCKER_BUILD_ARGS)
 endef
 
 $(foreach tag,$(MULTIARCH_TAGS), \
 	$(eval $(call build_template,$(tag),multiarch/$(tag),$(call ma_stem,$(tag)))))
 
 $(foreach tag,$(OFFICIAL_TAGS), \
-	$(eval $(call build_template,$(tag),$(tag),$(call official_stem,$(tag)))))
+	$(eval $(call build_template,$(tag),$(tag),$(call official_stem,$(tag)),$(call official_plat,$(tag)))))
 
 djgpp\:6.1.0-build: %-build: Dockerfile.djgpp mani-wrapper.sh
 	$(QUIET_SETUP)docker build . -f $< -t mani/$* --build-arg IDENT=$(call ident,$*)
 
-git-check-build $(addsuffix -check-build,$(ALL_TAGS)): %-check-build:
+source-build: Dockerfile.source
+	$(QUIET_SETUP)\
+		SRC_TMP=$$(mktemp -d -p .) && \
+		{ git clone $${TEST_LOCAL:-../../} $${SRC_TMP} && \
+		  docker build . --build-arg SRC_TMP=$${SRC_TMP} -f $< -t mani/source; \
+		  rm -rf $${SRC_TMP}; }
+
+$(addsuffix -check-build,source git cross $(NONCROSS_TAGS)): %-check-build:
 	$(QUIET_SETUP)\
 	[ $$(docker image ls -q mani/$*) ] \
 		|| $(MAKE) $*-build $(if $(QUIET_SETUP),>/dev/null 2>/dev/null)
+$(addsuffix -check-build,$(CROSS_TAGS)): cross-check-build
 
 $(ALL_TAGS): export QUIET_SETUP=$(QUIET_TEST)
 $(ALL_TAGS): export TEST_REMOTE?=$(if $(TEST_LOCAL),\
@@ -61,7 +81,7 @@
 		--env IDENT=$(call ident,$*) \
 		--volume manicache:/ccache \
 		--network=manibuilder \
-		--name mani_$(call ident,$*) mani/$* \
+		--name mani_$(call ident,$*) mani/$(patsubst cross-%,cross,$*) \
 		"git fetch $(TEST_REMOTE) $(TEST_REVISION) && \
 		 git checkout FETCH_HEAD && \
 		 export CC='$(CC)' STRIP='$(STRIP)' LIBS_BASE='$(LIBS_BASE)' && \
@@ -91,7 +111,8 @@
 			--env IDENT=$(call ident,$*) \
 			--volume manicache:/ccache \
 			--network=manibuilder \
-			mani/$* $(patsubst %,"%",$(SHELL_ARG)); \
+			mani/$(patsubst cross-%,cross,$*) \
+			$(patsubst %,"%",$(SHELL_ARG)); \
 	fi
 
 .PHONY: $(foreach s,-build -check-build -shell, $(addsuffix $(s),$(ALL_TAGS)))
