=== debian/changelog ===
flashprog (1.5-2~exp1) experimental; urgency=medium

  * libflashprog-dev: M-A same
  * Update Standards-Version
  * Install udev rules on linux only to fix another FTBFS on hurd

 -- Jakob Haufe <sur5r@debian.org>  Sun, 15 Feb 2026 11:51:10 +0100

flashprog (1.5-2~exp0) experimental; urgency=medium

  * Adjust B-D to fix FTBFS on hurd
  * Add patch from upstream to fix FTBFS on x32

 -- Jakob Haufe <sur5r@debian.org>  Sat, 14 Feb 2026 13:02:20 +0100

flashprog (1.5-1) unstable; urgency=medium

  * New upstream version 1.5

 -- Jakob Haufe <sur5r@debian.org>  Fri, 13 Feb 2026 21:16:30 +0100

flashprog (1.4-2) unstable; urgency=medium

  * Bump Standards-Version
  * Add basic autopkgtest
  * d/u/metadata: Add bug tracker
  * libflashprog1: M-A same

 -- Jakob Haufe <sur5r@debian.org>  Sun, 18 Jan 2026 21:27:07 +0100
