=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: flashprog
 Section: electronics
-Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders: Jakob Haufe <sur5r@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
 Build-Depends-Arch: libftdi1-dev,
-                    libgpiod-dev,
+                    libgpiod-dev [linux-any],
                     libjaylink-dev,
                     libpci-dev,
                     meson,
                     pkgconf,
                     systemd-dev [linux-any],
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://flashprog.org/
 Vcs-Browser: https://salsa.debian.org/electronics-team/flashprog
 Vcs-Git: https://salsa.debian.org/electronics-team/flashprog.git
@@ -90,6 +89,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Multi-Arch: same
 Description: Identify, read, write, erase, and verify BIOS/ROM/flash chips - library
  flashprog is a tool for identifying, reading, writing, verifying and erasing
  flash chips. It's often used to flash BIOS/EFI/coreboot/firmware/optionROM
@@ -114,6 +114,7 @@
 Architecture: any
 Depends: libflashprog1 (= ${binary:Version}),
          ${misc:Depends}
+Multi-Arch: same
 Description: Identify, read, write, erase, and verify BIOS/ROM/flash chips - development
  flashprog is a tool for identifying, reading, writing, verifying and erasing
  flash chips. It's often used to flash BIOS/EFI/coreboot/firmware/optionROM
