=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(DEB_HOST_ARCH_OS), linux)
	INSTALL_UDEV_RULES=true
else
	INSTALL_UDEV_RULES=false
endif


%:
	dh $@ --buildsystem=meson

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dinstall_udev_rules=$(INSTALL_UDEV_RULES) \
		-Dprogrammer=all
